#!/bin/bash

n=$1

if [[ -z $n ]]
then
    echo "usage: gen-qf.bash <N>"
    exit 1
fi

if [[ $n == 0 || $n == 1 ]]
then
    echo "error: $n is not square-free"
    exit 1
fi

[[ $n < 0 ]] && n_abs=$(( -n )) || n_abs=$n

for power in $(factor $n_abs | sed -e 's/^.*: //' | tr ' ' '\n' | sort | uniq -c | awk '{print $1}')
do
    if [[ $power > 1 ]]
    then
	echo "error: $n is not square-free"
	exit 1
    fi
done

echo "[1,0]*[1,0]=[1,0]"
echo "[1,0]*[0,1]=[0,1]"

if [[ $n -gt 0 ]]
then
    if (( $n % 4 == 1 ))
    then
	D=$(( (n-1)/4 ))
	echo "[0,1]*[0,1]=[$D,1]"
    else
	echo "[0,1]*[0,1]=[$n,0]"
    fi
else
    if (( $n % 4 == -3 ))
    then
	D=$(( (n-1)/4 ))
	echo "[0,1]*[0,1]=[$D,1]"
    else
	echo "[0,1]*[0,1]=[$n,0]"
    fi
fi

echo "[1,0]^0=[1,0]"
echo "[0,1]^0=[0,1]"
echo "[1,0]^1=[1,0]"

if [[ $n -gt 0 ]]
then
    if (( $n % 4 == 1 ))
    then
	D=$(( (n-1)/4 ))
	echo "[0,1]^1=[1,-1]"
    else
	echo "[0,1]^1=[0,-1]"
    fi
else
    if (( $n % 4 == -3 ))
    then
	echo "[0,1]^1=[1,-1]"
    else
	echo "[0,1]^1=[0,-1]"
    fi
fi
